import tkinter as tk
from tkinter import ttk
from tkinter import scrolledtext
from tkinter import Menu
from tkinter import messagebox as msg

win=tk.Tk()
win.title("Python GUI")
win.iconbitmap('pyc.ico')

# 메시지박스 위젯 
def _msgBox():
    ret =msg.askyesno("Askyesno Messagr Box", "Is it correct?")
    if ret >0: # 왼쪽 버튼 클릭시 리턴값이 0초과인 듯 함
        print("RETRY")
    else:
        print("CANCEL")
    
# 메뉴 생성
menu_bar = Menu(win)
win.config(menu=menu_bar) 

# 메뉴 아이템 생성
file_menu = Menu(menu_bar,tearoff=0) # 메뉴안에 메뉴를 생성=>(메뉴 안) 아이템칸 생성
file_menu.add_command(label="New") # 아이템 추가
file_menu.add_command(label="Exit",command=win.quit) # 아이템 추가 및 입력 받을 시 콜백함수 호출
file_menu.add_separator()
menu_bar.add_cascade(label="File",menu=file_menu)

help_menu=Menu(menu_bar, tearoff=0)
menu_bar.add_cascade(label="Help",menu=help_menu)
help_menu.add_command(label="About",command=_msgBox)    


# 탭 생성에 필요한 탭 컨트롤 생성
tabControl=ttk.Notebook(win)

# 새로운 탭(탭1) 추가
tab1=ttk.Frame(tabControl)
tabControl.add(tab1, text="Tab1")

# 새로운 탭(탭2) 추가
tab2=ttk.Frame(tabControl)
tabControl.add(tab2, text="Tab2")

# grid메소드과  비슷, fill은 제공된 공간을 점유하도록 지정, expand는 여분의 공간을 채우기 위해 확장할건지
tabControl.pack(expand=1,fill="both") 

# tab1에 라벨프레임 생성
mighty= ttk.LabelFrame(tab1,text="Mighty python")
mighty.grid(column=0, row=0,padx=8,pady=4)


# (tab1-라벨프레임 내) 라벨 생성
a_label=ttk.Label(mighty,text="Enter a name:")
a_label.grid(column=0, row=0,sticky='W')

def click_me():
    action.configure(text="Hello"+name.get()+''+number_chosen.get())

# (tab1-라벨프레임 내) 엔트리 위젯
name= tk.StringVar()
name_entered = ttk.Entry(mighty, width=12, textvariable=name)
name_entered.grid(column=0, row=1)


# (tab1-라벨프레임 내) 버튼 위젯
action=ttk.Button(mighty, text="Click Me!", command=click_me)
action.grid(column=2, row=1)

ttk.Label(mighty,text="Choose a number").grid(column=1,row=0)

# (tab1-라벨프레임 내) 콤보박스 위젯
number=tk.StringVar()
number_chosen=ttk.Combobox(mighty,width=12,textvariable=number, state= 'readonly')
number_chosen['values']=(1,2,4,42,100)
number_chosen.grid(column=1,row=1)
number_chosen.current(0)

# (tab1-라벨프레임 내) 스크롤드 테스트  위젯
scrol_w = 30
scrol_h =3
scr = scrolledtext.ScrolledText(mighty, width=scrol_w, height=scrol_h, wrap=tk.WORD)
scr.grid(column=0, columnspan=3, sticky='WE')


# (tab1-라벨프레임 내) 그리드 설정 변경
for child in mighty.winfo_children():
    child.grid_configure(sticky='W')
    
# tab2에 라벨프레임 생성
mighty2= ttk.LabelFrame(tab2,text="The Snake")
mighty2.grid(column=0, row=0,padx=8,pady=4)
    
# (tab2-라벨프레임 내) 체크버튼 위젯
chVarDis=tk.IntVar()
check1 = tk.Checkbutton(mighty2, text="Disabled",variable=chVarDis,state="disabled")
check1.select()
check1.grid(column=0, row=0, sticky=tk.W)

chVarUn=tk.IntVar()
check2 = tk.Checkbutton(mighty2, text="UnChecked",variable=chVarUn)
check2.deselect()
check2.grid(column=1, row=0, sticky=tk.W)

chVarEn=tk.IntVar()
check3 = tk.Checkbutton(mighty2, text="Enabled",variable=chVarEn)
check3.select()
check3.grid(column=2, row=0, sticky=tk.W)

# (tab2-라벨프레임 내) 라디오버튼 위젯
colors=["Blue","Gold","Red"]

def radCall(): 
    redsel=radVar.get()
    mighty2.configure(text=colors[redsel]) # 라디오버튼 클릭시 라벨프레임 텍스트 변경


radVar = tk.IntVar()

radVar.set(99)

for col in range(3):
    curRad=tk.Radiobutton(mighty2,text=colors[col], variable =radVar,value=col, command=radCall)
    curRad.grid(column=col, row=1, sticky=tk.W)

# (tab2-라벨프레임 내) 라벨 프레임 위젯
buttons_frame = ttk.Labelframe(mighty2, text='Labels in a Frame')
buttons_frame.grid(column=0, row=2)

ttk.Label(buttons_frame,text="Label1").grid(column=0,row=0)
ttk.Label(buttons_frame,text="Label2").grid(column=1,row=0)
ttk.Label(buttons_frame,text="Label3").grid(column=2,row=0)

# 프로그램 실행 시 마우스 커서 위치
name_entered.focus()

# 이벤트순환문 실행
win.mainloop()
